/********************************************************************/
/*                                                                  */
/*   Program Name :  monit3                                         */
/*                                                                  */
/*      Version:  1.00  2006-11-02                                  */
/*                2.14  2007-02-23   minor revision                 */
/*                                                                  */
/*      Copyright (c) 2006-2007 T.Kondo/NICT All Right Reserved     */
/*                                                                  */
/********************************************************************/
/*
 ho|ukah{[h̘A^pvO
         by T.Kondo 2006.02.23  start development (base is monit2.c)   
                    2006.11.02  display which board is used

     gp@  monit3 span sfreq adbit numch [datafile [logfile]] 
             span  Wԁibj
                      ̒l2GByteȏP̃t@CƂč쐬
                      ̒lł2Gbyteɕt@C쐬
                   sfreq  TvOg
                       0.04,0.1,0.2,0.5,1,2,4,8,16,32,64 (for MHz) (default is 1)
                      PF32,64K5/VSSP32̂
                      QF̒lŃZbgƁAK5/VSSP32ɂ
                         tB^[X[ɃZbg
                         ̒l̏ꍇAtB^[͈ȉ̂悤ɃZbg
                      Fsample(MHz)   0.04 0.1 0.2 0.5 1 2 4 8 16 32 64 
                      Ffilter(MHz)     2   2   2   2  2 2 2 4  8 16  0
                                                   (0̓X[Ӗj
                   adbit  `c\irbg)
                       1,2,4,8    (default is 1)
                   numch  `l
                         1 ܂ 4 (default is 1)
                   datafile -- f[^t@C
                      ftHgtds.data
                   logfile -- Ot@C
                      ftHgmonit3.log
                      ftHg̃Ot@C͏㏑
                      [U[logfilep[^Ŏw肵Ot@Cɂ
                      O̓Ayh

*/
#define PROGRAM_VERSION "Ver. 2007-02-23"

#include "chead.h"      // common header for IP-VLBI utilities
#include "libipvlbi_board.h"  // library for IP-VLBI sampler board

/* set global variables */
char dev[] = DEV_FILE;  // IP-VLBI BOARD control variable
int fd_in;                 // IP-VLBI BOARD control variable
double telapsed;           // to measure processing time
double telongest, teshortest;  // for statistics
time_t tstart0,tnow0,tstart, tfinish;    //           "
time_t timeold;
//char* dflt_logdir=K5LOGDIRDFLT;        // default log file directory
char* dflt_logdir="./";        // default log file directory
char logdir[60];               // logfile directory
char hostname[20];             // host name
char lbuf[80];
logval_t lg;

/* set interrupt handler */
void Handler(int n);

void SetHandler(void)
{
    if(signal(SIGINT, Handler) == SIG_ERR){
        printf("Signal handler set up failure!\n");
        abort();
    }
}

void Handler(int n)
{
     static int x=0;
     int rv;
     printf("Interrupt occurred !!\n");

     /* sampling stop */

     rv = ioctl(fd_in, TDSIO_SAMPLING_STOP);
     if (rv == -1) {
     perror("stop sampling failed, anyway stop ");
     goto end;
     }
     else {
        printf("Stop sampling!\n");
     }

     //close(fd_out);

 end:
     tfinish= time(NULL);
     telapsed = difftime(tfinish,tstart);
     sprintf(lbuf,"monit3 stop sampling after %f minutes sampling.",telapsed/60.0);
     //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
     LogWrite4(&lg, 0, 0.0, 0, lbuf);
     close(fd_in);
     exit(0);
}

void occurrence_plot(int *noc, int nline, int col_max, int interval)
{
  /* Occurrence hist gram plot */
  int n,k;
  //int nline;
  int nmax;
  int kmax;
  //int col_max;
  double step;
  char iline[70];
  //nline=4;
  //col_max=50;
  
  // find max
  nmax=0;
  for(n=0; n<100; n++){
     if(noc[n] > nmax) nmax=noc[n];
  }
  step=(double)nmax/(double)nline;
  
  printf("          OCCURRENCE VS TIME (every %d minutes)  MAX=%d\n",interval,nmax);
  // each line data generate
  for(n=nline; n>0; n--){
      for(k=0; k<col_max; k++){
          kmax=k;
          if(noc[k]==-1){
              iline[k]='\0';
              break;
          }
          if((double)noc[k] > (double)(n-1)*step){
              iline[k]='*';
          } else {
              iline[k]=' ';
          }
      }
      iline[kmax+1]='\0';
      printf("   |%s|\n",iline);
  }
  
  for(k=0; k<col_max; k++) iline[k]='-';
  iline[col_max]='\0';
  printf("   +%s+\n",iline);
  printf("\033[1A");  // move cursol 1 lines up
  printf("   NOW-------->PAST(MAX:%d minutes)\n",interval*col_max);
}

//int sampleget_monit(char* outfile, int span, int sfreq, 
//                    int adbit, int numch, int filter, int adjust)
int sampleget_monit2(char* outfile, vssp_param_t *sp)
{
    //char outfile[] = "./tds.data";
    //char dev[] = "/dev/tds0";
    //int fd_in;
    int fd_out;
    mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
    int rv;
    unsigned int timen,day,sec; // foCXǂݍ񂾌݂̎i[
    unsigned int secold;
    int i,h,m,s;
    int n;
    int secforce;
    int ihist[4][8];
    int hmax[4];
    char iline[70];
    char* lev0="          ";
    char* lev1="*         ";
    char* lev2="**        ";
    char* lev3="***       ";
    char* lev4="****      ";
    char* lev5="*****     ";
    char* lev6="******    ";
    char* lev7="*******   ";
    char* lev8="********  ";
    char* lev9="********* ";
    char* lev10="**********";
    char* levd="<         ";
    char* levu="         >";
    int w1,w2,w3,mm;
    int beat;
    double sum[4],ave[4];
    int nave;
    char cbuf[20];
#ifdef _VSSP32
    struct tdsio tdsio;   // for setting DC_OFFSET or getting DC_OFFSET
#endif
    
    //int span, sfreq;
#ifdef _VSSP32
    int headbit=256;  // default header bit number  for K5/VSSP32
#else
    int headbit=64;  // header bit number  for K5/VSSP
#endif
    int allbyte;     // TvOoCg
    int bitsec;       // Pb̃rbgiwb_[܂ށj
    int bytesec;       // Pb̃oCgiwb_[܂ށj
    int c,k;
    int nkai;
    int err, adjusted;
    int dcoffset[4];
    int numerr; // error occurence number cpounter
    int noc[100];  // to store recent # of error occurred
    int noc_interval_minutes;  // interval in minutes
    int noc_carry; // flag 
    int col_max=60;
    int nline=4;
    //unsigned int sampling1, freq, width, stat;
    int sampling1, freq, width, stat, filter0;
    unsigned int ref, pps, rhz, pll;
    int ch, pos;
    u_int8_t sfreq_t, sbit_t, numch_t;
    u_int8_t sampling;
    //u_int32_t buf[BUFSIZ * 2];
    u_int32_t buf[1024 * 2];
    //double telapsed;           // to measure processing time   (move to groval area)
    //time_t tstart, tfinish;    //           "
    //printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ: 1024 for K5/VSSP   8192 for K5/VSSP32
    //int xdata[BUFSIZ * 16];  // f[^̃f[^[p
//    int xdata[1024 * 64];  // f[^̃f[^[p
    
    int nbyte = sizeof(buf);   // nbyte = 8192

    //printf(" span = %d\n",span);    // debug
    //printf(" sfreq= %d\n",sfreq);   // debug

    telongest=0.0;
    teshortest=0.0;
    numerr=0;
    adjusted=0;
    
    for(n=0; n<100; n++) noc[n]=-1;
    noc[0]=0;
    
    tstart0= time(NULL);
    timeold=tstart0;
    noc_carry=0;
    noc_interval_minutes=20;

loopmain:

    /* sampler open */
    fd_in = open(dev, O_RDONLY);
    //fd_in = open("/dev/tds0", O_RDONLY);
    if (fd_in == -1) {
        perror("device open() error ");
        return -1;
    }
    

#ifdef _VSSP32
    if((rv=ioctl(fd_in,TDSIO_INIT)) == -1) {
        perror("ioctl() INIT failed ");
        goto end;
    }
#endif
    /* board status check */
    if((rv=check_vssp(fd_in, &stat, 1)) == -1) {
        perror("ioctl() status get failed ");
        goto end;
    }

      
    /* output file open */
/*
    fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
    if (fd_out == -1) {
        perror("output file open() error");
        goto end;
    }
*/
    /* sampling parameters set */
    //if((rv=set_vssp_sparam(fd_in,sfreq,adbit,numch,filter,1))==-1){
    if((rv=set_vssp_sparam(fd_in,sp,1))==-1){
        printf("sampling set failed \n");
        goto end;
    }
    
    if (sp->sfreq >= 40) {
       bitsec=sp->sfreq*1000 + headbit ;
    } else { 
       bitsec=sp->sfreq*1000*1000 + headbit ;
    }

    bitsec=bitsec*sp->adbit*sp->numch;   // bit number per second

    allbyte= 2000000000;
/*
    bytesec=bitsec/8;
    allbyte=bytesec*span;
    if (allbyte > 2000000000){
       allbyte= 2000000000;
       secforce=allbyte/bytesec;
       printf(" # of bytes force to set to 2GB because it exceeds 2GB\n");  // debug
       printf(" Obserbasation span (sec) reduced to %d\n",secforce);  // debug
    }
    printf(" bitsec  = %d\n",bitsec);  // debug
    printf(" bytesec = %d\n",bytesec);  // debug
    printf(" allbyte = %d\n",allbyte);  // debug
*/
    /* get sampling parameters from a board */
    //if ((rv=get_vssp_sparam(fd_in,&freq,&width,&ch,&filter0,1))== -1) {
    if ((rv=get_vssp_sparam(fd_in,sp,1))== -1) {
        perror("ioctl() get sampling parameter failed ");
        goto end;
    } else {
        printf("sampling setting is %d kHz %d BIT %d CH",
                  sp->freqkhz,sp->adbit,sp->numch);
#ifdef _VSSP32
        printf(" FILTER %d MHz\n",sp->filter);
#else
        printf("\n");
#endif
    }   

    /* board time get */
 /*
    rv = ioctl(fd_in, TDSIO_GET_TIME, &timen);
    if (rv == -1) {
        perror("ioctl() time get failed ");
        return -1;
    }
       day=TDS_GET_DAYS(timen);
       sec=TDS_GET_SEC(timen);
       sec2hms(sec,&h,&m,&s);
    //printf("get count day from device [%5d]\n",TDS_GET_DAYS(timen));
    //printf("get count sec from device [%5d]\n",TDS_GET_SEC(timen));
    printf("%03d %02d:%02d:%02d\n",day,h,m,s);
 */

       
    rv = ioctl(fd_in, TDSIO_BUFFER_CLEAR);   // {[hFIFÕNA[
    if (rv == -1) {
        perror("ioctl() FIFO clear failed ");
        goto end;
    } else {
        printf("ioctl() FIFO clear succeed\n");
    }

    rv = ioctl(fd_in, TDSIO_SAMPLING_START);
    if (rv == -1) {
        perror("ioctl() start sampling failed ");
              printf("Probably time was not set for the IP-VLBI board.\n");
              printf("Please set time using timesettk and try again.\n");
        goto end;
    } else {
        printf("ioctl() start sampling succeed\n");
    }
#ifdef _VSSP32
    sprintf(lbuf,"monit2 sampling start : %d kHz (filter %d MHz) %d BIT %d CH",
                        sp->freqkhz,sp->filter,sp->adbit,sp->numch);
#else
    sprintf(cbuf,"monit2 sampling start : %d kHz %d BIT %d CH",
                        sp->freqkhz,sp->adbit,sp->numch);
#endif
    //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
    LogWrite4(&lg, 0, 0.0, 0, lbuf);
    
    
    tstart= time(NULL);

  /* MONITOR START */
  
    printf("\033[2J");   //  Erase the screen ( move the cursor to home ) for VT100
    printf("\033[H");   //  move the cursor to home
    printf("********************************************************************\n");
    printf("*                                                                  *\n");
    printf("*   MONIT3 (sampling reliability test for K5/VSSP or K5/VSSP32)    *\n");
    printf("*                by T.Kondo/NICT  (%s)                *\n",PROGRAM_VERSION);
#ifdef _VSSP32
    printf("*                    Target Board is K5/VSSP32                     *\n");
#else
    printf("*                     Target Board is K5/VSSP                      *\n");
#endif
    printf("*                                                                  *\n");
    printf("*                        CTRL C  for STOP                          *\n");
    printf("*                                                                  *\n");
    printf("*******T***********************************************KONDO********\n");
    //printf("\n");
    printf("     log file            : %s\n",lg.logfile);
    printf("     sampling parameters : %d kHz (filter %d MHz) %d BIT %d CH\n",
                         sp->freqkhz,sp->filter,sp->adbit,sp->numch);
    //printf("\n");
    printf("     number of error occurence is %d\n",numerr);
    if(numerr !=0){
       printf("          shortest period (minutes) = %f\n",teshortest/60.0);
       printf("          longest  period (minutes) = %f\n",telongest/60.0);
    }
    printf("\n");
    
    c = 0;

    beat=0;
    nave=0;
    nkai=0;
    //while (c < BUFSIZ * BUFSIZ) {
    while (c <=  allbyte) {      // loop until CTRL-C
       rv = read(fd_in, buf, nbyte);
       if (rv == -1) {
          printf("read() failed   ");
          ioctl(fd_in, TDSIO_GET_ERROR, &err); printf("Error code = %d\n",err);  // debug for VSSP32
          tfinish= time(NULL);
          telapsed = difftime(tfinish,tstart);
          printf("error occurred after %f minutes sampling.\n",telapsed/60.0);
          sprintf(lbuf,"monit2 error (%d) occurred after %f minutes sampling.",err,telapsed/60.0);
          //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
          LogWrite4(&lg, 0, 0.0, 1, lbuf);
          if(numerr==0){
              telongest=telapsed;
              teshortest=telapsed;
          }
          if(telapsed < teshortest) teshortest=telapsed;
          if(telapsed > telongest) telongest=telapsed;
          numerr++;
          noc[0]++;
          //goto end;
          close(fd_in);
          goto loopmain;  // do again  
       }

       //if((c != 1) && (c !=0)){ goto bypass1;}

//       parseADdata(buf, rv, sp->adbit, xdata, &pos);
       /* Histgram Statistics */
/*
       w3=0;
       for(k=0; k<pos; k++){
          w1=xdata[k];
          if(sp->adbit == 8) w2=w1/32; 
          if(sp->adbit == 4) w2=w1/2; 
          if(sp->adbit == 2) w2=w1;
          if(sp->adbit == 1) w2=w1;
          ihist[w3][w2]+=1;
          sum[w3]+=(double)w1;  // for average calc
          w3++;
          if( w3 == 4 ) w3 =0; 
          if( sp->numch == 1 ) w3 =0; 
       }
       nave=pos/sp->numch;
       for(k=0; k<sp->numch; k++) ave[k]=sum[k]/(double)nave - 255.0/2.0;  // assuming 8bit AD
*/
       if((c != 1) && (c !=0)) goto bypass1;  // to reduce the refresh rate

       //if(c !=0 ) printf("\033[10A");  // move cursol 10 lines up
       //if(c !=0 ) printf("\033[1A");  // move cursol 1 lines up
       if(c !=0 ) printf("\033[8A");  // move cursol 8 lines up
       
       tnow0= time(NULL);
       telapsed = difftime(tnow0,tstart0);
       /* heart beat */
       if(beat == 0) printf("  sampling going on  *     time(minutes) since start : %f\n",telapsed/60.0);
       if(beat == 1) printf("  sampling going on   *\n");
       beat++;
       if(beat==2) beat=0;
       
       telapsed = difftime(tnow0,timeold);
       if(telapsed >= noc_interval_minutes*60.0){
           noc_carry=1;
           timeold=tnow0;
       }
       /* Histgram occurrence shift by one */
       if(noc_carry==1){
          for(n=99; n>0; n--){
             noc[n]=noc[n-1];
          }
          noc[0]=0;
          noc_carry=0;
       }
       
       /* Histgram occurrence Plot */
       printf("\n");
       occurrence_plot(noc, nline, col_max, noc_interval_minutes);

       bypass1:  ;
       
       /* histgram data initialize */
       for(w1=0; w1<4; w1++){
           for(k=0; k<8; k++){
              ihist[w1][k]=0;
           }
           sum[w1]=0.0;
           ave[w1]=0.0;
       }
       nave=0;
       //printf(" nbyte = %d\n",nbyte);   // debug
       // rv = write(fd_out, buf, rv);
       //c= c+ nbyte;
       c++;
       //printf("c=%d\n", c); printf("\033[10A"); // debug
       if(c == 40*sp->numch ) {
          c=1;
          nkai++;
          if(nkai == 3){
              nkai=0;
//              if(adjust==1) break;  // exit while loop
          }
       }
    }


    rv = ioctl(fd_in, TDSIO_SAMPLING_STOP);
    if (rv == -1) {
        perror("ioctl() stop sampling failed ");
        goto end;
    }
    else {
        printf("ioctl() stop sampling succeed\n");
    }
       
/*
    close(fd_out);
*/
       /* board time get */
/*
    rv = ioctl(fd_in, TDSIO_GET_TIME, &timen);
    if (rv == -1) {
        perror("ioctl() time get failed ");
        return -1;
    }
       day=TDS_GET_DAYS(timen);
       sec=TDS_GET_SEC(timen);
       sec2hms(sec,&h,&m,&s);
    //printf("get count day from device [%5d]\n",TDS_GET_DAYS(timen));
    //printf("get count sec from device [%5d]\n",TDS_GET_SEC(timen));
    printf("%03d %02d:%02d:%02d\n",day,h,m,s);
*/

 end:
    close(fd_in);

    return rv;
}

int sampleget_monit3(spget_t *spg, int numerr, int scan,
                 int *noc, int nline, int col_max, int noc_interval_minutes)
{
    //char dev[] = "/dev/tds0";
    char dev[] = DEV_FILE;
//    int fd_in;  for monit3 (fd_in is in gloabal)
    int fd_out;
    mode_t ofilemode = S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH;
    int rv;
    unsigned int timen,day,sec; // foCXǂݍ񂾌݂̎i[
    int i,h,m,s;
    int secforce;
    int headbit;
//#ifdef _VSSP32
//    int headbit=256;  // default header bit number  for K5/VSSP32
//#else
//    int headbit=64;  // header bit number  for K5/VSSP
//#endif
    int allbyte;     // TvOoCg
    int bitsec;       // Pb̃rbg@iwb_[rbg܂ށj
    int bytesec;       // Pb̃oCg@iwb_[rbg܂ށj
    int c;
    int beat,cbeat,beatinc;
    int sfreq, adbit, numch, span;
    int filter;
    int err;
    int ntry, ntrymax;
    int nbyte;
    int sampling1, freq, width, filter0;
    int ch;
    double dallbyte, dc;
    int f_c;   // file number counter  in case of file exceeds > 2Gbyte
    int oflag,iflag;  //oflag =1 :output file opened
                      //iflag =1 :input file opened
    char cbuf[160];
    char outfile[120];
    char outname2[120]; // for extra output
    // ----------
    unsigned int sfreq_u, sbit_u, numch_u, filter_u;
    u_int8_t sfreq_t, sbit_t, numch_t;
    u_int8_t sampling;
#ifdef _VSSP32
    char buf[64*1024];
    struct tdsauxio tdsaux;
#else
    u_int32_t buf[BUFSIZ * 2];
#endif
//    logval_t lg;
     //printf("BUFSIZ   %d\n",BUFSIZ);   // BUFSIZ was 1024

    headbit=64;  // header bit number  for K5/VSSP
    oflag=0;
    iflag=0;
    span=spg->span;
    sfreq=spg->sp.sfreq;
    adbit=spg->sp.adbit;
    numch=spg->sp.numch;
    filter=spg->sp.filter;
    strcpy(outfile,spg->outfile);
//    lg=spg->lg;
    

    //ntrymax=5;  // the number to try again when read error occured
    ntrymax=10;  // the number to try again when read error occured
    ntry=0;     // try again counter (if read failure, try again)
    nbyte = sizeof(buf);   // nbyte = 8192  !! check
    
    printf("  sampleget: Ver. 2005-12-28\n");
    /*
    printf(" span = %d\n",span);    // debug
    printf(" sfreq= %d\n",sfreq);   // debug
    printf(" adbit= %d\n",adbit);   // debug
    printf(" numch= %d\n",numch);   // debug
   */

    /* sampling duration check */
    if (span <= 0) {
       printf(" parameter span (duration in sec) should be positive!\n");
       // nothing to do
       return -1;
    }


    /* sampler open */
    fd_in = open(dev, O_RDONLY);
    //fd_in = open("/dev/tds0", O_RDONLY);
    if (fd_in == -1) {
       perror("device open() error ");
       return -1;
    }
    iflag=1;

    /* output file open */
    fd_out = open(outfile, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
    if (fd_out == -1) {
       perror("output file open() error");
       goto end;
    }
    oflag=1;
    sprintf(cbuf,"sampleget: output file = %s",outfile);
    printf("  %s\n",cbuf);
    LogWrite4(&lg,0,0.0,0,cbuf);

#ifdef _VSSP32  // just for the case of VSSP32 only
    if((rv=ioctl(fd_in, TDSIO_INIT)) == -1){
        perror("  sampleget: ioctl() INIT failed ");
        goto end;
    } else {
        //printf("  sampleget: ioctl() INIT succeed\n");
        printf("  sampleget: ioctl() INIT ");
    }
    /* set AUX field data */
    if(spg->sp.vsspaux.size > 0) {    // default size should be 20
        tdsaux.auxsize=spg->sp.vsspaux.size;
        for(i=0; i<tdsaux.auxsize; i++) tdsaux.auxfield[i]=spg->sp.vsspaux.bdat[i];
        if((rv=ioctl(fd_in, TDSIO_SET_AUX, &tdsaux)) == -1){
            perror("  sampleget: ioctl() SET_AUX failed ");
            goto end;
        } else {
            //printf("  sampleget: ioctl() SET_AUX succeed\n");
            printf("SET_AUX ");
        }
    }
    /* get AUX field data */
    if((rv=ioctl(fd_in, TDSIO_GET_AUX, &tdsaux)) == -1){
       perror("  sampleget: ioctl() GET_AUX failed ");
            goto end;
    } else {
            printf("GET_AUX ");
    }
    printf("succeed\n");
    headbit=64+32+8*tdsaux.auxsize;   // header bit calc
    if(headbit != 256){
        printf("  sampleget:Warning!! header bits (%d) is different from default value (256)\n",headbit);
    } else {
        printf("  sampleget: header bits = %d\n",headbit);
    }
#endif

    /* sampling parameters set */
    //if((rv=set_vssp_sparam(fd_in,sfreq,adbit,numch,filter,0))==-1){
    if((rv=set_vssp_sparam(fd_in, &spg->sp,0))==-1){
        printf("  sampleget: sampling parameter set failed \n");
        goto end;
    }

    /* check file size etc */
    //if (sfreq >= 40) { bitsec=sfreq*1000 + headbit ;}   
    //else { bitsec=sfreq*1000*1000 + headbit ;}
    if (sfreq == 40 || sfreq == 100 || sfreq == 200 || sfreq == 500 ) {     //2005-12-21
        bitsec=sfreq*1000 ;
    } else { 
        bitsec=sfreq*1000*1000;
    }

    bitsec=(bitsec*adbit*numch)+headbit;   // bit number per second (including header bits)

    bytesec=bitsec/8;
    allbyte=bytesec*span;
    dallbyte=(double)bytesec*(double)span; 

    /* File maximum bytes check */
       //if (allbyte > FILEMAXSIZE){
//      if (dallbyte > (double)FILEMAXSIZE){  // 2002-10-21
//         allbyte= FILEMAXSIZE;
//         secforce=allbyte/bytesec;
//         printf(" # of bytes force to set to %d Bytes because it exceeds %d Bytes\n",
//              allbyte,FILEMAXSIZE);  // debug
//         printf(" Obserbasation span (sec) reduced to %d\n",secforce);  // debug
//      }
    sprintf(cbuf,"sampleget: bits/sec=%d  bytes/sec=%d  all_bytes=%g",bitsec, bytesec,dallbyte);  // debug
    printf("  %s\n",cbuf);

    /* get sampling parameters from a board */
    //if ((rv=get_vssp_sparam(fd_in,&freq,&width,&ch,&filter0,0))== -1) {
    if ((rv=get_vssp_sparam(fd_in, &spg->sp,0))== -1) {
        perror("  sampleget: ioctl() get sampling parameter failed ");
        goto end;
    }  

#ifdef _VSSP32
    sprintf(cbuf,"sampleget: sampling parameters are %d kHz (filter %d MHz) %d BIT %d CH",
                         spg->sp.freqkhz,spg->sp.filter,spg->sp.adbit,spg->sp.numch);
#else
    sprintf(cbuf,"sampleget: sampling parameters are %d kHz %d BIT %d CH",
                         spg->sp.freqkhz,spg->sp.adbit,spg->sp.numch);
#endif
    printf("  %s\n",cbuf);
    LogWrite4(&lg,0,0.0,0,cbuf);

       /* board time get */
 /*
    rv = ioctl(fd_in, TDSIO_GET_TIME, &timen);
    if (rv == -1) {
        perror("ioctl() time get failed ");
        return -1;
    }
       day=TDS_GET_DAYS(timen);
       sec=TDS_GET_SEC(timen);
       sec2hms(sec,&h,&m,&s);
    //printf("get count day from device [%5d]\n",TDS_GET_DAYS(timen));
    //printf("get count sec from device [%5d]\n",TDS_GET_SEC(timen));
    printf("%03d %02d:%02d:%02d\n",day,h,m,s);
 */

       
    rv = ioctl(fd_in, TDSIO_BUFFER_CLEAR);   // {[hFIFÕNA[
    if (rv == -1) {
        perror("  sampleget: ioctl() FIFO clear failed ");
        goto end;
    }
    else {
        printf("  sampleget: ioctl() FIFO clear succeed\n");
    }

    /* sampling start */

    rv = ioctl(fd_in, TDSIO_SAMPLING_START);
    if (rv == -1) {
        perror("  sampleget: ioctl() start sampling failed ");
        printf("  sampleget:  Probably time was not set for the IP-VLBI board.\n");
        printf("  sampleget:  Please set time using timesettk and try again.\n");
        goto end;
    }
    else {
        printf("  sampleget: ioctl() start sampling succeed\n");
    }


  /* MONITOR START */
  
    printf("\033[2J");   //  Erase the screen ( move the cursor to home ) for VT100
    printf("\033[H");   //  move the cursor to home
    printf("********************************************************************\n");
    printf("*                                                                  *\n");
    printf("*   MONIT3 (sampling reliability test for K5/VSSP or K5/VSSP32)    *\n");
    printf("*                by T.Kondo/NICT  (%s)                *\n",PROGRAM_VERSION);
#ifdef _VSSP32
    printf("*                    Target Board is K5/VSSP32                     *\n");
#else
    printf("*                     Target Board is K5/VSSP                      *\n");
#endif
    printf("*                                                                  *\n");
    printf("*                        CTRL C  for STOP                          *\n");
    printf("*                                                                  *\n");
    printf("*******T***********************************************KONDO********\n");
    //printf("\n");
    printf("     log file  : %s\n",lg.logfile);
    printf("     data file : %s\n",spg->outfile);
    printf("     sampling  : %d kHz (filter %d MHz) %d BIT %d CH  %d sec\n",
                         spg->sp.freqkhz,spg->sp.filter,spg->sp.adbit,spg->sp.numch,
                         spg->span);
    //printf("\n");
    printf("     current scan # : %d    error occurred is %d\n",scan,numerr);
//    if(numerr !=0){
//       printf("          shortest period (minutes) = %f\n",teshortest/60.0);
//       printf("          longest  period (minutes) = %f\n",telongest/60.0);
//    }
       /* Histgram occurrence Plot */
       printf("\n");
       occurrence_plot(noc, nline, col_max, noc_interval_minutes);
       printf("\n");
       printf("\n");



    beat=0;
    cbeat=0;
    //beatinc=2;
    beatinc=40*numch;

    c = 0;
    dc= 0.0;   // 2002-10-21
    f_c=0;    // 2002-10-21
    //ntry=0;   // try again counter (if read failure, try again)
    //while (c <=  allbyte) {
    while (1) {                   // 2002-10-21
try_again:
       rv = read(fd_in, buf, nbyte);
#ifdef _VSSP32
       if (rv == -1) {
          printf("  sampleget: read() failed ");
          ioctl(fd_in, TDSIO_GET_ERROR, &err); printf("Error code = %d\n",err);  // debug for VSSP32
          sprintf(cbuf,"sampleget: read() failed! Error code = %d",err);  // 2006-01-24
          //LogWrite4(&lg,0,0.0,1,"sampleget: read() failed");
          LogWrite4(&lg,0,0.0,1,cbuf);
          //goto end;
//          if((rv = ioctl(fd_in, TDSIO_SAMPLING_STOP))==-1) goto end;
//          printf("STOP ");
//          //if((rv = ioctl(fd_in, TDSIO_BUFFER_CLEAR))==-1) goto end;
//          //printf("FIFO_CLEARED ");
//          if((rv = ioctl(fd_in, TDSIO_SAMPLING_START))==-1) goto end;
//          printf("START ");
          ntry++;                                  // 2006-01-24
          if(ntry > ntrymax) {
              printf("  sampleget: !! retry number (%d) exceeds maximum (%d)\n",ntry,ntrymax);
              sprintf(cbuf,"sampleget: !! retry number (%d) exceeds maximum (%d)\0",ntry,ntrymax);
              LogWrite4(&lg,0,0.0,1,cbuf);
              printf("  sampleget: !! so give up retry\n");
              sprintf(cbuf,"sampleget: !! so give up retry\0");
              LogWrite4(&lg,0,0.0,1,cbuf);
              goto end;
          }

          goto try_again;
       }
#else
       if (rv == -1) {
          perror("  sampleget: read() failed ");
          ioctl(fd_in, TDSIO_GET_ERROR, &rv); printf("Error code = %d\n",rv);  // debug for VSSP32
          
          LogWrite4(&lg,0,0.0,1,"sampleget: read() failed");
          //try sampling start again 
          ntry++;
          if(ntry > ntrymax) {
              printf("  sampleget: !! retry number (%d) exceeds maximum (%d)\n",ntry,ntrymax);
              sprintf(cbuf,"sampleget: !! retry number (%d) exceeds maximum (%d)\0",ntry,ntrymax);
              LogWrite4(&lg,0,0.0,1,cbuf);
              printf("  sampleget: !! so give up retry\n");
              sprintf(cbuf,"sampleget: !! so give up retry\0");
              LogWrite4(&lg,0,0.0,1,cbuf);
              goto end;
          }
          rv = ioctl(fd_in, TDSIO_SAMPLING_START);
          if (rv == -1) {
              perror("  sampleget: ioctl() re-start sampling failed ");
              sprintf(cbuf,"sampleget: re-start sampling failed at retry %d/%d\0",ntry,ntrymax);
              LogWrite4(&lg,0,0.0,1,cbuf);
              goto end;
          } else {
              printf("  sampleget: ioctl() re-start sampling succeed at retry %d/%d\n",ntry,ntrymax);;
              sprintf(cbuf,"sampleget: re-start sampling at retry %d/%d\0",ntry,ntrymax);
              LogWrite4(&lg,0,0.0,1,cbuf);
          } 
          goto try_again;
       }
#endif
       //printf(" nbyte = %d  rv = %d\n",nbyte,rv);   // debug
       rv = write(fd_out, buf, rv);  // should check error (file full etc)
       /* add on 2005-01-30 */
       if (rv == -1) {
          perror("  sampleget: write() failed ");
          sprintf(cbuf,"sampleget: write() failed : %s\0",strerror(errno));
          LogWrite4(&lg,0,0.0,1,cbuf);
          //try file close and move to another disk 
          //  this is supposing write error occurred due to disk full 
          c=0;
          close(fd_out);
          oflag=0;
          f_c++;
          //new directory name set in out file name
          if(spg->outdirtab.ndir < spg->outdirtab.dirnum){ //2005-01-30
              strcpy(spg->outdir,spg->outdirtab.dir[spg->outdirtab.ndir]); 
              spg->outdirtab.ndir++;   
              sprintf(cbuf,"OUT directory changed  :  %s",spg->outdir);
              LogWrite4(&lg,0,0.0,0,cbuf);
          } else {
              goto end;
          }
          strcpy(outfile,spg->outdir);
          strcat(outfile,spg->fname);

          // new file name creation     XXXX.datN   where N=1,2,3......

          strcpy(outname2,outfile);
          sprintf(cbuf,"%d\0",f_c);
          strcat(outname2,cbuf);
          printf("  sampleget: outfile %d %s\n",f_c,outname2);  //debug
          /* output file open */
          fd_out = open(outname2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
          if (fd_out == -1) {
             perror("  sampleget: output file open() error");
             goto end;
          }
          oflag=1;
          sprintf(cbuf,"sampleget: output file = %s",outname2);
          printf("  %s\n",cbuf);
          LogWrite4(&lg,0,0.0,0,cbuf);
       }
       
      
       //if(c !=0 ) printf("\033[8A");  // move cursol 8 lines up
       if(cbeat ==0 ) {
          printf("\033[1A");  // move cursol 1 lines up
          tnow0= time(NULL);
          telapsed = difftime(tnow0,tstart0);
          /* heart beat */
          if(beat == 0) printf("  sampling going on  *     time(minutes) since start : %f\n",telapsed/60.0);
          if(beat == 1) printf("  sampling going on   *\n");
          beat++;
          if(beat==2) beat=0;
       }
       cbeat++;
       if(cbeat==beatinc) cbeat=0;

       /****** add end *******/
       c+= nbyte;

       /* add on 2002-10-21 */
        dc+=(double)nbyte;
        if( dc > dallbyte) {   // sampling end
            goto exithere;
        }
        if(spg->f_size_mode==1 && c >  FILEMAXSIZE) { // newfile creation
            c=0;
            close(fd_out);
            oflag=0;
            f_c++;
            // new file name creation     XXXX.datN   where N=1,2,3......
            strcpy(outname2,outfile);
            sprintf(cbuf,"%d\0",f_c);
            strcat(outname2,cbuf);
            printf("  sampleget: outfile %d %s\n",f_c,outname2);  //debug
            /* output file open */
            fd_out = open(outname2, O_WRONLY | O_CREAT | O_TRUNC, ofilemode);
            if (fd_out == -1) {
               perror("  sampleget: output file open() error");
               goto end;
            }
            oflag=1;
            sprintf(cbuf,"sampleget: output file = %s",outname2);
            printf("  %s\n",cbuf);
            LogWrite4(&lg,0,0.0,0,cbuf);
        }
            
    }

exithere:
       /* sampling stop */

    rv = ioctl(fd_in, TDSIO_SAMPLING_STOP);
    if (rv == -1) {
        perror("  sampleget: ioctl() stop sampling failed ");
        goto end;
    }
    else {
        printf("  sampleget: ioctl() stop sampling succeed\n");
    }

end:
    if(oflag == 1)  close(fd_out);
    if(iflag == 1)  close(fd_in);

    if(rv < 0){     //2006-02-24
      return rv;
    } else {
      return ntry;
    }
    //return ntry;
}

int main(int argc, char **argv)
{
    //char dev[] = "/dev/tds0";
    char outfile[120];
    char cbuf[120];
    char logfile[80];
    char* dflt_fname="tds.data";
    char* dflt_logfile="monit3.log";
    int rv;
    int span, sfreq, adbit, numch, filter, adjust;
    int no_filter;
    int err, beat,n;
    int numerr; // error occurence number counter
    int scan;   // total scan counter
    int noc[100];  // to store recent # of error occurred
    int noc_interval_minutes;  // interval in minutes
    int noc_carry; // flag 
    int col_max=60;
    int nline=4;
    int logmode;
    double freq;
    spget_t spg;
    //logval_t lg;
    //vssp_param_t sp;

    if(argc <= 1 ){
          printf("monit3 %s\n",PROGRAM_VERSION);
          printf("Usage: monit3 span [sfreq adbit numch filename logfile]\n");
          printf("\n");
          printf("         where  span ---- duration (sec)\n");
          printf("                          (-VE means allow big file)\n");
          printf("                          (otherwise devided into 2GB files)\n");
#ifdef _VSSP32
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           0.04,0.1,0.2,0.5,1,2,4,8,16,32,64 (for MHz)\n");
          printf("                     Note1: 32 and 64 are valid only for K5/VSSP32\n");
          printf("                     Note2: -VE means ""no use of digital filter"" at K5/VSSP32\n");
          printf("                            In case of +VE, relation between sampling frequency\n");
          printf("                            (Fs) and filter frequency(Ff) is as follows;\n");
          printf("                            Fs(MHz)   0.04 0.1 0.2 0.5 1 2 4 8 16 32 64\n");
          printf("                            Ff(MHz)     2   2   2   2  2 2 2 4  8 16  0\n");
          printf("                                   (valid for K5/VSSP32. 0 means through)\n");
          printf("                          default is 32\n");
#else
          printf("                sfreq ---- sampling frequency\n");
          printf("                           40,100,200,500 (for kHz)\n");
          printf("                           1,2,4,8,16 (for MHz)\n");
          printf("                          default is 16\n");
#endif
          printf("                adbit ---- A/D bit\n");
          printf("                           1,2,4,8\n");
          printf("                          default is 1\n");
          printf("                numch ---- number of channel\n");
          printf("                           1,4\n");
          printf("                          default is 4\n");
          printf("                filename ---- out file name\n");
          printf("                          default is tds.data\n");
          printf("                logfile ---- log out file name\n");
          printf("                          default is monit3.log\n");
          printf("                          if default logfile is used, it is overwritten.\n");
          printf("                          But if logfile is set by ""logfile"" parameter,\n");
          printf("                          log will be appended to logfile.\n");
          exit(0);
    }

    spg.sp.vsspaux.fmt=2;  // default AUX field format for K5/VSSP32  (sampling)
    logmode=0;  // log file is first cleared
    spg.f_size_mode=1;    //1: divided into 2GB size file  0: no limitation
    span = atoi(*(argv + 1 ));
    if(span < 0 ){
       span=-span;
       spg.f_size_mode=0;
    }
    //sfreq= atoi(*(argv + 2 ));
    if (argc>=3){
        freq= atof(*(argv + 2 ));
    } else {
#ifdef _VSSP32
        freq=32.0;
#else
        freq=16.0;
#endif
    }
    no_filter=0;
    if(freq < 0.0) {
      freq=-freq;
      no_filter=1;
    }
    sfreq=(int)freq;
    if(sfreq==0) sfreq=(int)(freq*1000.0);
    // filter frequency set
    spg.sp.filter=2;   // default is minimum settable filter frequency (MHz)
    if(sfreq==4) spg.sp.filter=2;
    if(sfreq==8) spg.sp.filter=4;
    if(sfreq==16) spg.sp.filter=8;
    if(sfreq==32) spg.sp.filter=16;
    if(sfreq==64) spg.sp.filter=0;
    if(no_filter==1) spg.sp.filter=0;

    if (argc>=4){
       adbit = atoi(*(argv + 3 ));
    } else {
       adbit=1;
    }

    if (argc>=5){
       numch = atoi(*(argv + 4 ));
    } else {
       numch=4;
    }

    if (argc>=6){
          strcpy(outfile,*(argv+5));
    } else {
          strcpy(outfile,dflt_fname);
    }
    if (argc>=7){
          strcpy(logfile,*(argv+6));
          logmode=1; // log is appended to existed log file
    } else {
          strcpy(logfile,dflt_logfile);
    }
    /* log info set if necessary */
    strcpy(lg.logfile,logfile);
    lg.hostname[0]='\0';
    lg.logdir[0]='\0';
    //lg.logfiletype=-1;    //-1: no log   0: log out
    lg.logfiletype=0;    //-1: no log   0: log out
    spg.lg=lg;
//    if(logmode==0){
//       sprintf(cbuf,"rm -f %s\0",logfile);
//       system(cbuf);    // delete logfile
//    }

    printf(" span    = %d\n",span);    // debug
#ifdef _VSSP32
    printf(" sfreq   = %d (freq(MHz) = %f)\n",sfreq,freq);   // debug
    if(spg.sp.filter==0){
       printf(" filter  = through\n");   // debug
    } else {
       printf(" filter  = %d (MHz)\n",spg.sp.filter);   // debug
    }
#else
    printf(" sfreq   = %d\n",sfreq);   // debug
#endif
    printf(" adbit   = %d\n",adbit);   // debug
    printf(" numch   = %d\n",numch);   // debug
    printf(" outfile = %s\n",outfile);   // debug
    if(lg.logfiletype==0){
        printf(" logfile = %s\n",logfile);   // debug
    }
    sprintf(cbuf,"sampling start: span=%d sfreq=%d adbit=%d numch=%d outfile=%s\0",
                 span,sfreq,adbit,numch,outfile);
    LogWrite4(&lg, 0, 0.0, 0, cbuf);
    
#ifdef _VSSP32
    /* prepare AUX field for K5/VSSP32 */
    /* get host name for AUX filed */
    
    hostget(spg.sp.vsspaux.hostname8);
    strcpy(spg.sp.vsspaux.sid," ");
    strcpy(spg.sp.vsspaux.sid2,"  ");
    strcpy(spg.sp.vsspaux.station8,"sampling");
    spg.sp.vsspaux.size=20;  // this is fixed
    spg.sp.vsspaux.filter=spg.sp.filter;
    vssp_aux_make(&spg.sp.vsspaux);
#endif

    spg.span=span;
    spg.sp.sfreq=sfreq;
    spg.sp.adbit=adbit;
    spg.sp.numch=numch;
    strcpy(spg.outfile,outfile);
    //spg.f_size_mode=1;    //1: divided into 2GB size file  0: no limitation
    
/*
    printf(" span = %d\n",span);    // debug
    printf(" sfreq= %d\n",sfreq);   // debug
    printf(" adbit= %d\n",adbit);   // debug
    printf(" numch= %d\n",numch);   // debug
*/
    printf("*******************************************\n");
    printf("*  K5/VSSP (IP-VLBI) board sampling test  *\n");
    printf("*          MONIT3 (%s)       *\n",PROGRAM_VERSION);
    printf("*                by                       *\n");
    printf("*           T.Kondo/NICT                  *\n");
    printf("*******************************************\n");
    printf(" \n");

    SetHandler();
#ifdef _VSSP32
    sprintf(lbuf,"monit3(%s) start for K5/VSSP32 on %s",PROGRAM_VERSION,hostname);
#else
    sprintf(lbuf,"monit3(%s) start for K5/VSSP32 on %s",PROGRAM_VERSION,hostname);
#endif
    //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
    LogWrite4(&lg, 0, 0.0, 0, lbuf);
    
    telongest=0.0;
    teshortest=0.0;
    numerr=0;
    scan=0;
    
    for(n=0; n<100; n++) noc[n]=-1;
    noc[0]=0;
    
    tstart0= time(NULL);
    timeold=tstart0;
    noc_carry=0;
    noc_interval_minutes=20;
    

loop_entry:

    tstart= time(NULL);

  /* MONITOR START */
  
//    if(numerr !=0){
//       printf("          shortest period (minutes) = %f\n",teshortest/60.0);
//       printf("          longest  period (minutes) = %f\n",telongest/60.0);
//    }
//    printf("\n");
    
    //rv=sampleget_monit(outfile, span, sfreq, adbit, numch, filter, adjust);
    scan++;
    rv=sampleget_monit3(&spg,numerr,scan, noc, nline, col_max, noc_interval_minutes);
    if(rv !=0) {
        tfinish= time(NULL);
        telapsed = difftime(tfinish,tstart);
        printf("error occurred after %f minutes sampling.\n",telapsed/60.0);
        sprintf(lbuf,"monit3 error (%d) occurred after %f minutes sampling.",err,telapsed/60.0);
        //if(LogWrite2(logdir,hostname,0,0.0,0,lbuf) == -1) printf("LogWrite2 error!\n");
        LogWrite4(&lg, 0, 0.0, 1, lbuf);
        if(numerr==0){
            telongest=telapsed;
            teshortest=telapsed;
        }
        if(telapsed < teshortest) teshortest=telapsed;
        if(telapsed > telongest) telongest=telapsed;
        numerr++;
        noc[0]++;
    }
       tnow0= time(NULL);
       telapsed = difftime(tnow0,tstart0);
       /* heart beat */
//       if(beat == 0) printf("  sampling going on  *     time(minutes) since start : %f\n",telapsed/60.0);
//       if(beat == 1) printf("  sampling going on   *\n");
//       beat++;
//       if(beat==2) beat=0;
       
       telapsed = difftime(tnow0,timeold);
       if(telapsed >= noc_interval_minutes*60.0){
           noc_carry=1;
           timeold=tnow0;
       }
       /* Histgram occurrence shift by one */
       if(noc_carry==1){
          for(n=99; n>0; n--){
             noc[n]=noc[n-1];
          }
          noc[0]=0;
          noc_carry=0;
       }
       
       /* Histgram occurrence Plot */
       //printf("\n");
       //occurrence_plot(noc, nline, col_max, noc_interval_minutes);
    goto loop_entry;


    return 0;
}
